## pdal 2.3.0+ds

=== CMakeLists.txt ===
#
# top-level CMake configuration file for PDAL
#
# (based originally on the libLAS files copyright Mateusz Loskot)

cmake_minimum_required(VERSION 3.5)

project(PDAL VERSION 2.3.0 LANGUAGES CXX C)
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

set(ROOT_DIR "${PROJECT_SOURCE_DIR}")
include(${ROOT_DIR}/cmake/common.cmake NO_POLICY_SCOPE)

#------------------------------------------------------------------------------
# internal cmake settings
#------------------------------------------------------------------------------

set(CMAKE_COLOR_MAKEFILE ON)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
include(FeatureSummary)

# Allow advanced users to generate Makefiles printing detailed commands
mark_as_advanced(CMAKE_VERBOSE_MAKEFILE)

#------------------------------------------------------------------------------
# PDAL general settings
#------------------------------------------------------------------------------

#
# Must be changed if there is an ABI change.  This builds the SONAME
# that's embedded in the library itself.
#
set(PDAL_SOLIB_MAJOR 13)
#
# Change if there's a new release with no ABI change
#
set(PDAL_SOLIB_MINOR 0)
#
# Build number.  Increment for builds within minor versions.  Probably
# always 0 for PDAL
#
set(PDAL_SOLIB_BUILD 0)


set(PDAL_API_VERSION ${PDAL_SOLIB_MAJOR})
set(PDAL_BUILD_VERSION
    "${PDAL_SOLIB_MAJOR}.${PDAL_SOLIB_MINOR}.${PDAL_SOLIB_BUILD}")
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Name of C++ library

#
# To facilitate one-library linking, we do special things for various platforms.
#
# On Linux we install a linker script that we call libpdalcpp.so and it
# in turn links libpdal_base.so and libpdal_util.so
#
# On OSX we reexport the symbols from libpdal_util.dylib into libpdalcpp.dylib
# See below for the rest of the magic.
#
if (APPLE OR WIN32)
    set(PDAL_BASE_LIB_NAME pdalcpp)
else()
    set(PDAL_BASE_LIB_NAME pdal_base)
endif()
set(PDAL_LIB_NAME pdalcpp)
set(PDAL_UTIL_LIB_NAME pdal_util)
set(PDAL_BOOST_LIB_NAME pdal_boost)
set(PDAL_KAZHDAN_LIB_NAME pdal_kazhdan)
set(PDAL_TEST_SUPPORT_OBJS pdal_test_support)

set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

set(PDAL_OUTPUT_LIB_DIR "${PDAL_BINARY_DIR}/${PDAL_LIB_INSTALL_DIR}")
set(PDAL_OUTPUT_BIN_DIR "${PDAL_BINARY_DIR}/${PDAL_BIN_INSTALL_DIR}")

# allow override of PDAL_PLUGIN_INSTALL_PATH path
if (NOT PDAL_PLUGIN_INSTALL_PATH)
    if (WIN32)
        set(PDAL_PLUGIN_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/${PDAL_BIN_INSTALL_DIR}")
    else()
        set(PDAL_PLUGIN_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/${PDAL_LIB_INSTALL_DIR}")
    endif()
endif()
file(MAKE_DIRECTORY "${PDAL_OUTPUT_LIB_DIR}")
file(MAKE_DIRECTORY "${PDAL_OUTPUT_BIN_DIR}")

include(${PDAL_CMAKE_DIR}/rpath.cmake)

# wipe lib/ drectory on clean. It will have plugins that could be out of date
# in the next build
set_directory_properties(PROPERTY ADDITIONAL_MAKE_CLEAN_FILES
    "${PDAL_OUTPUT_LIB_DIR}/*")

if(WIN32)
  add_definitions("-DPDAL_DLL_EXPORT=1")
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${CMAKE_BUILD_TYPE} "${PDAL_OUTPUT_LIB_DIR}")
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${CMAKE_BUILD_TYPE} "${PDAL_OUTPUT_BIN_DIR}")
  # ---[ Windows requires DLLs (shared libraries) to be installed in
  # ---[ the same directory as executables
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${CMAKE_BUILD_TYPE} "${PDAL_OUTPUT_BIN_DIR}")
endif(WIN32)

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${PDAL_OUTPUT_LIB_DIR}")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PDAL_OUTPUT_BIN_DIR}")
if(WIN32)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PDAL_OUTPUT_BIN_DIR}")
else()
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PDAL_OUTPUT_LIB_DIR}")
endif()

# Choose package components

include(${PDAL_CMAKE_DIR}/options.cmake)

#------------------------------------------------------------------------------
# General build settings
#------------------------------------------------------------------------------

set(PDAL_BUILD_TYPE ${CMAKE_BUILD_TYPE})

#------------------------------------------------------------------------------
#  Dependencies.
#------------------------------------------------------------------------------

include(${PDAL_CMAKE_DIR}/gdal.cmake)
include(${PDAL_CMAKE_DIR}/geotiff.cmake)  # Optional (not really)
include(${PDAL_CMAKE_DIR}/lazperf.cmake)  # Optional
include(${PDAL_CMAKE_DIR}/laszip.cmake)  # Optional
include(${PDAL_CMAKE_DIR}/threads.cmake)
include(${PDAL_CMAKE_DIR}/zlib.cmake)
include(${PDAL_CMAKE_DIR}/lzma.cmake)
include(${PDAL_CMAKE_DIR}/zstd.cmake)
include(${PDAL_CMAKE_DIR}/test.cmake)
include(${PDAL_CMAKE_DIR}/ctest.cmake)
include(${PDAL_CMAKE_DIR}/libxml2.cmake)
include(${PDAL_CMAKE_DIR}/dimension.cmake)
include(${PDAL_CMAKE_DIR}/arbiter.cmake)
include(${PDAL_CMAKE_DIR}/nlohmann.cmake)
include(${PDAL_CMAKE_DIR}/openssl.cmake) # Optional

#------------------------------------------------------------------------------
# generate the pdal_features.hpp header
#------------------------------------------------------------------------------

# from http://stackoverflow.com/questions/1435953/how-can-i-pass-git-sha1-to-compiler-as-definition-using-cmake
include(GetGitRevisionDescription)
get_git_head_revision(GIT_REFSPEC GIT_SHA1)

configure_file(
  "${PROJECT_SOURCE_DIR}/gitsha.cpp.in"
  "${PROJECT_SOURCE_DIR}/pdal/gitsha.cpp")

# needs to come before configuration of pdal_features
if(APPLE)
    option(PDAL_BUNDLE "Create PDAL as Application Bundle on OSX" FALSE)
    if (PDAL_BUNDLE)
        set(PDAL_APP_BUNDLE 1)
    endif()
endif()

set(pdal_features_hpp_in "${CMAKE_CURRENT_SOURCE_DIR}/pdal_features.hpp.in")
set(pdal_features_hpp
    "${CMAKE_CURRENT_BINARY_DIR}/include/pdal/pdal_features.hpp")
configure_file(${pdal_features_hpp_in} ${pdal_features_hpp})

#------------------------------------------------------------------------------
# subdirectory controls
#------------------------------------------------------------------------------

# PDAL_TARGET_OBJECTS is used to collect the driver object libraries
set(PDAL_TARGET_OBJECTS "")

if (WITH_TESTS)
    enable_testing()
endif()

add_subdirectory(plugins)

#include_directories(vendor/pdalboost)
if (WITH_TESTS)
    include (${PDAL_CMAKE_DIR}/gtest.cmake)
    add_subdirectory(test)
endif()
add_subdirectory(dimbuilder)
add_subdirectory(vendor/pdalboost)
add_subdirectory(vendor/arbiter)
add_subdirectory(vendor/kazhdan)
add_subdirectory(pdal/util)
add_subdirectory(tools)
add_subdirectory(apps)
#
# On OSX we reexport the symbols in libpdal_util.dylib into libpdalcpp.dylib
# so that users only need link libpdalcpp.
#
if (APPLE)
    set(PDAL_REEXPORT "-Wl,-reexport_library,$<TARGET_FILE:${PDAL_UTIL_LIB_NAME}>")
    #
    # This allows the rpath reference for the reexported library (above) to
    # be found.
    #
    set(PDAL_LIBDIR "-L$<TARGET_FILE_DIR:${PDAL_UTIL_LIB_NAME}>")
endif()

file(GLOB BASE_SRCS
    ${PDAL_FILTERS_DIR}/*.cpp
    ${PDAL_IO_DIR}/*.cpp
    ${PDAL_KERNELS_DIR}/*.cpp
    ${PDAL_SRC_DIR}/*.cpp
    ${PDAL_SRC_DIR}/compression/*.cpp)
file(GLOB_RECURSE PRIVATE_SRCS
    ${PDAL_FILTERS_DIR}/private/*.cpp
    ${PDAL_IO_DIR}/private/*.cpp
    ${PDAL_KERNELS_DIR}/private/*.cpp
    ${PDAL_SRC_DIR}/private/*.cpp)
list(APPEND SRCS ${BASE_SRCS} ${PRIVATE_SRCS})

#
# Remove stuff we don't want to build.
#
if (NOT PDAL_HAVE_LIBXML2)
    file(GLOB XML_SRCS
        io/Ilvis2MetadataReader.cpp
        io/Ilvis2Metadata.cpp
        io/Ilvis2Reader.cpp
        ${PDAL_SRC_DIR}/DbWriter.cpp
        ${PDAL_SRC_DIR}/DbReader.cpp
        ${PDAL_SRC_DIR}/XMLSchema.cpp)
    list(REMOVE_ITEM SRCS ${XML_SRCS})
endif()
if (NOT PDAL_HAVE_ZSTD)
    file(GLOB ZSTD_SRCS
        ${PDAL_SRC_DIR}/compression/ZstdCompression.cpp)
    list(REMOVE_ITEM SRCS ${ZSTD_SRCS})
endif()
if (NOT PDAL_HAVE_ZLIB)
    file(GLOB ZLIB_SRCS
        ${PDAL_SRC_DIR}/compression/DeflateCompression.cpp)
    list(REMOVE_ITEM SRCS ${ZLIB_SRCS})
endif()
if (NOT PDAL_HAVE_LZMA)
    file(GLOB LZMA_SRCS
        ${PDAL_SRC_DIR}/compression/LzmaCompression.cpp)
    list(REMOVE_ITEM SRCS ${LZMA_SRCS})
endif()
if (NOT PDAL_HAVE_LAZPERF)
    file(GLOB LAZPERF_SRCS
        ${PDAL_SRC_DIR}/compression/LazPerfVlrCompression.cpp)
    list(REMOVE_ITEM SRCS ${LAZPERF_SRCS})
endif()

if (GDAL_VERSION VERSION_LESS 3.0.0)
    file(GLOB PROJPIPELINE_FILTER_SRCS
        ${PDAL_FILTERS_DIR}/ProjPipelineFilter.cpp)
    list(REMOVE_ITEM SRCS ${PROJPIPELINE_FILTER_SRCS})
endif()
PDAL_ADD_LIBRARY(${PDAL_BASE_LIB_NAME} ${SRCS} ${RPLY_SRCS})

#
# Interface include directories allow downstream project to get the directory
# without specification.
#
target_include_directories(${PDAL_BASE_LIB_NAME}
    PRIVATE
        ${ROOT_DIR}
        ${PROJECT_BINARY_DIR}/include
        ${PDAL_VENDOR_DIR}
        ${PDAL_VENDOR_DIR}/eigen
        ${PDAL_VENDOR_DIR}/pdalboost
        ${LIBXML2_INCLUDE_DIR}
        ${ZSTD_INCLUDE_DIRS}
        ${NLOHMANN_INCLUDE_DIR}
        ${GDAL_INCLUDE_DIR}
        ${LASZIP_INCLUDE_DIR}
)
target_link_libraries(${PDAL_BASE_LIB_NAME}
    PRIVATE
        ${CMAKE_THREAD_LIBS_INIT}
        ${GDAL_LIBRARY}
        ${GEOTIFF_LIBRARY}
        ${LASZIP_LIBRARY}
        ${LIBXML2_LIBRARIES}
        ${ZLIB_LIBRARIES}
        ${LIBLZMA_LIBRARIES}
        ${ZSTD_LIBRARIES}
        ${WINSOCK_LIBRARY}
        ${PDAL_REEXPORT}
        ${PDAL_UTIL_LIB_NAME}
        ${PDAL_ARBITER_LIB_NAME}
        ${PDAL_KAZHDAN_LIB_NAME}
        ${LAZPERF_LIBRARY}
    INTERFACE
        ${PDAL_LIBDIR}
)
target_compile_definitions(${PDAL_BASE_LIB_NAME}
    PRIVATE
        ${LASZIP_DEFINES}
)
set_target_properties(${PDAL_BASE_LIB_NAME} PROPERTIES
    VERSION ${PDAL_BUILD_VERSION}
    SOVERSION ${PDAL_API_VERSION}
    CLEAN_DIRECT_OUTPUT 1)

# shut off -Wpedantic selectively
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU" )
set_source_files_properties(filters/PoissonFilter.cpp PROPERTIES COMPILE_FLAGS -Wno-pedantic)
endif()

#
# On Linux, we install a linker script as libpdalcpp.so.  That file
# specifies linking in libpdal_base.so and libpdal_util.so.  This allows
# users to link a single library, libpdalcpp
#
if (UNIX AND NOT APPLE)
    set(LIBNAME ${CMAKE_SHARED_LIBRARY_PREFIX}${PDAL_LIB_NAME})
    install(FILES ${LIBNAME} DESTINATION ${PDAL_LIB_INSTALL_DIR}
        RENAME ${LIBNAME}${CMAKE_SHARED_LIBRARY_SUFFIX})
endif()

#
# Installation
#

#
# Only install compression headers if we're building with the particular
# compression type.
#
if (NOT PDAL_HAVE_ZSTD)
    set(ZSTD_EXCLUDES PATTERN pdal/compression/Zstd* EXCLUDE)
endif()
if (NOT PDAL_HAVE_ZLIB)
    set(ZLIB_EXCLUDES PATTERN pdal/compression/Deflate* EXCLUDE)
endif()
if (NOT PDAL_HAVE_LZMA)
    set(LZMA_EXCLUDES PATTERN pdal/compression/Lzma* EXCLUDE)
endif()
if (NOT PDAL_HAVE_LAZPERF)
    set(LAZPERF_EXCLUDES PATTERN pdal/compression/LazPerf* EXCLUDE)
endif()

install(DIRECTORY ${PDAL_INCLUDE_DIR}/pdal
    DESTINATION include
    FILES_MATCHING PATTERN "*.hpp"
    PATTERN "gitsha.h"
#    PATTERN "pdal/private" EXCLUDE
#    PATTERN "pdal/io/private" EXCLUDE
#    PATTERN "pdal/pdal/private" EXCLUDE
#    PATTERN "pdal/util/private" EXCLUDE
#    PATTERN "pdal/filters/private" EXCLUDE
#    ${ZSTD_EXCLUDES}
#    ${ZLIB_EXCLUDES}
#    ${LZMA_EXCLUDES}
#    ${LAZPERF_EXCLUDES}
)

install(DIRECTORY ${PDAL_KERNELS_DIR}
    DESTINATION include/pdal
    FILES_MATCHING PATTERN "*.hpp"
#    PATTERN "private" EXCLUDE
)
install(DIRECTORY ${PDAL_IO_DIR}
    DESTINATION include/pdal
    FILES_MATCHING PATTERN "*.hpp"
#    PATTERN "private" EXCLUDE
)
install(DIRECTORY ${PDAL_FILTERS_DIR}
    DESTINATION include/pdal
    FILES_MATCHING PATTERN "*.hpp"
#    PATTERN "private" EXCLUDE
)

install(FILES ${DIMENSION_OUTFILE} ${pdal_features_hpp}
  DESTINATION include/pdal
)

#
# CPACK
#
include (${PDAL_CMAKE_DIR}/cpack.cmake)

add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

export(
    TARGETS
        ${PDAL_BASE_LIB_NAME} ${PDAL_UTIL_LIB_NAME}
    FILE
        "${PDAL_BINARY_DIR}/PDALTargets.cmake")

install(
    EXPORT
        PDALTargets

=== apps/CMakeLists.txt ===
#
# ./apps CMake configuration file for PDAL utilties
#
# (based originally on the libLAS files copyright Mateusz Loskot)

cmake_minimum_required(VERSION 2.8)

#------------------------------------------------------------------------------
# Configure build targets
#------------------------------------------------------------------------------

set(PDAL_APP pdal)

if (APPLE AND PDAL_BUNDLE)
    add_executable(${PDAL_APP} MACOSX_BUNDLE pdal.cpp)
else (APPLE AND PDAL_BUNDLE)
    add_executable(${PDAL_APP} pdal.cpp)
endif(APPLE AND PDAL_BUNDLE)
pdal_target_compile_settings(${PDAL_APP})
target_link_libraries(${PDAL_APP}
    PRIVATE
        ${PDAL_BASE_LIB_NAME}
        ${PDAL_UTIL_LIB_NAME}
        ${GDAL_LIBRARY}
        ${WINSOCK_LIBRARY}
)
target_include_directories(${PDAL_APP} PRIVATE
    ${NLOHMANN_INCLUDE_DIR}
    ${PDAL_INCLUDE_DIR}
    ${GDAL_INCLUDE_DIR}
    ${PROJECT_BINARY_DIR}/include)

#------------------------------------------------------------------------------
# Targets installation
#------------------------------------------------------------------------------

if (APPLE AND PDAL_BUNDLE)
    install(TARGETS ${PDAL_APP}
        BUNDLE DESTINATION ${PDAL_BIN_INSTALL_DIR})
else(APPLE AND PDAL_BUNDLE)
    install(TARGETS ${PDAL_APP}
        RUNTIME DESTINATION ${PDAL_BIN_INSTALL_DIR})
endif(APPLE AND PDAL_BUNDLE)

set(PKGCONFIG_LIBRARY_DEFINITIONS "")
set(PDAL_INCLUDE_DEFINITIONS
    "-I${CMAKE_INSTALL_PREFIX}/include -I${GDAL_INCLUDE_DIR}")
set(PKGCONFIG_LIBRARY_DEFINITIONS "${PKGCONFIG_LIBRARY_DEFINITIONS} gdal")

if(LIBXML2_FOUND)
    set(PKGCONFIG_LIBRARY_DEFINITIONS
        "${PKGCONFIG_LIBRARY_DEFINITIONS} libxml-2.0")
    set(PDAL_INCLUDE_DEFINITIONS
        "${PDAL_INCLUDE_DEFINITIONS} -I${LIBXML2_INCLUDE_DIR}")
endif()

set(PDAL_INCLUDE_DEFINITIONS ${PDAL_INCLUDE_DEFINITIONS})

if (LASZIP_FOUND)
    set(PDAL_INCLUDE_DEFINITIONS
        "${PDAL_INCLUDE_DEFINITIONS} -I${LASZIP_INCLUDE_DIR}")
endif()

file(MAKE_DIRECTORY "${PDAL_OUTPUT_LIB_DIR}/pkgconfig/")
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/pdal.pc.in
               ${CMAKE_CURRENT_BINARY_DIR}/pdal.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/pdal.pc
    DESTINATION "${PDAL_LIB_INSTALL_DIR}/pkgconfig/"
    PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ)

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/pdal-config.in"
               "${PDAL_OUTPUT_BIN_DIR}/pdal-config" @ONLY
               NEWLINE_STYLE UNIX)
install(PROGRAMS "${PDAL_OUTPUT_BIN_DIR}/pdal-config"
    DESTINATION
        "${CMAKE_INSTALL_PREFIX}/bin"
    PERMISSIONS
        OWNER_READ OWNER_WRITE OWNER_EXECUTE
        GROUP_READ GROUP_EXECUTE
        WORLD_READ WORLD_EXECUTE)

if(WIN32)
    # Autoconf compatibility variables to use the same script source.
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/pdal-config-bat.in"
                   "${PDAL_OUTPUT_BIN_DIR}/pdal-config.bat" @ONLY
                   NEWLINE_STYLE CRLF)
    install(PROGRAMS "${PDAL_OUTPUT_BIN_DIR}/pdal-config.bat"
        DESTINATION
            "${CMAKE_INSTALL_PREFIX}/bin"
        PERMISSIONS
            OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE
            WORLD_READ WORLD_EXECUTE)
endif()

=== dimbuilder/CMakeLists.txt ===
#
# The seemingly strange arrangement of this cmake file allows you to build
# this application as a standalone.
#
cmake_minimum_required(VERSION 2.8.6)

set(MAKE_COLOR_MAKEFILE ON)

if(NOT ROOT_DIR)
    project(DIMBUILDER)
    set(ROOT_DIR "${PROJECT_SOURCE_DIR}/..")
endif()

include(${ROOT_DIR}/cmake/common.cmake NO_POLICY_SCOPE)

#
# We include Utils.cpp here rather than linking in the Utils library because
# some people building linux packages disable rpath, which means that
# the Utils library can't be located when running dimbuilder, even though
# it has been built.
#
add_executable(dimbuilder
    DimBuilder.cpp
    ${PDAL_UTIL_DIR}/Utils.cpp
)
target_include_directories(dimbuilder PRIVATE
    ${PDAL_INCLUDE_DIR}
    ${NLOHMANN_INCLUDE_DIR}
)
PDAL_TARGET_COMPILE_SETTINGS(dimbuilder)
target_link_libraries(dimbuilder
    PRIVATE
        ${EXECINFO_LIBRARY}
        ${CMAKE_DL_LIBS}
)

=== plugins/CMakeLists.txt ===
include(${PDAL_CMAKE_DIR}/test.cmake)

add_subdirectory(faux)
if(BUILD_PLUGIN_I3S)
    if(NOT ZLIB_FOUND)
        message(FATAL_ERROR "Can't build i3s and slpk plugins without zlib")
    endif()
    add_subdirectory(i3s)
endif()

if(BUILD_PLUGIN_CPD)
    add_subdirectory(cpd)
endif(BUILD_PLUGIN_CPD)

if(BUILD_PLUGIN_DRACO)
    add_subdirectory(draco)
endif(BUILD_PLUGIN_DRACO)

if(BUILD_PLUGIN_ICEBRIDGE)
    if (NOT PDAL_HAVE_LIBXML2)
        message(FATAL_ERROR "Can't build icebridge plugin without libxml2")
    endif()
    add_subdirectory(icebridge)
endif()

if(BUILD_PLUGIN_HDF)
    add_subdirectory(hdf)
endif()

if(BUILD_PLUGIN_MATLAB)
    add_subdirectory(matlab)
endif()

if(BUILD_PLUGIN_MBIO)
    add_subdirectory(mbio)
endif()

if(BUILD_PLUGIN_MRSID)
    add_subdirectory(mrsid)
endif()

if(BUILD_PLUGIN_NITF)
    add_subdirectory(nitf)
endif()

if(BUILD_PLUGIN_OCI)
    if (NOT PDAL_HAVE_LIBXML2)
        message(FATAL_ERROR "Can't build OCI plugin without libxml2")
    endif()
    add_subdirectory(oci)
endif()

if(BUILD_PLUGIN_PGPOINTCLOUD)
    if (NOT PDAL_HAVE_LIBXML2)
        message(FATAL_ERROR "Can't build pgpointcloud plugin without libxml2")
    endif()
    add_subdirectory(pgpointcloud)
endif()

if(BUILD_PLUGIN_OPENSCENEGRAPH)
    add_subdirectory(openscenegraph)
endif()

if(BUILD_PLUGIN_RDBLIB)
    add_subdirectory(rdb)
endif(BUILD_PLUGIN_RDBLIB)

if(BUILD_PLUGIN_RIVLIB)
    add_subdirectory(rxp)
endif(BUILD_PLUGIN_RIVLIB)

if (BUILD_PLUGIN_FBX)
    add_subdirectory(fbx)
endif()

if(BUILD_PLUGIN_TEASER)
    add_subdirectory(teaser)
endif(BUILD_PLUGIN_TEASER)

if(BUILD_PLUGIN_TILEDB)
    add_subdirectory(tiledb)
endif()

if(BUILD_PLUGIN_E57)
    add_subdirectory(e57)
endif()

=== examples/writing-kernel/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(KernelTutorial)

find_package(PDAL 2.0.0 REQUIRED CONFIG)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

add_library(pdal_plugin_kernel_mykernel SHARED MyKernel.cpp)
target_link_libraries(pdal_plugin_kernel_mykernel PRIVATE ${PDAL_LIBRARIES})
target_include_directories(pdal_plugin_kernel_mykernel PRIVATE
                            ${PDAL_INCLUDE_DIRS})
target_link_directories(pdal_plugin_kernel_mykernel PRIVATE ${PDAL_LIBRARY_DIRS})

=== examples/writing-reader/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(ReaderTutorial)

find_package(PDAL 2.0 REQUIRED CONFIG)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

add_library(pdal_plugin_reader_myreader SHARED MyReader.cpp)
target_link_libraries(pdal_plugin_reader_myreader PRIVATE ${PDAL_LIBRARIES})
target_include_directories(pdal_plugin_reader_myreader PRIVATE
                            ${PDAL_INCLUDE_DIRS})
target_link_directories(pdal_plugin_reader_myreader PRIVATE ${PDAL_LIBRARY_DIRS})

=== examples/writing-writer/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(WriterTutorial)

find_package(PDAL 2.0.0 REQUIRED CONFIG)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

add_library(pdal_plugin_writer_mywriter SHARED MyWriter.cpp)
target_link_libraries(pdal_plugin_writer_mywriter PRIVATE ${PDAL_LIBRARIES})

target_link_directories(pdal_plugin_writer_mywriter PRIVATE ${PDAL_LIBRARY_DIRS})
target_include_directories(pdal_plugin_writer_mywriter PRIVATE
    ${PDAL_INCLUDE_DIRS})

=== pdal/util/CMakeLists.txt ===
#
# Make sure we don't attempt to add a library more than once
#
get_property(EXISTS GLOBAL PROPERTY _UTIL_INCLUDED)
if(EXISTS)
    return()
endif()

include(${PDAL_CMAKE_DIR}/execinfo.cmake)
include(${PDAL_CMAKE_DIR}/threads.cmake)
include(${PDAL_CMAKE_DIR}/unwind.cmake)

if(LIBUNWIND_FOUND)
    set(BACKTRACE_SOURCE BacktraceUnwind.cpp)
    set(BACKTRACE_LIBRARIES ${LIBUNWIND_LIBRARIES})
elseif(LIBEXECINFO_FOUND)
    set(BACKTRACE_SOURCE BacktraceExecinfo.cpp)
    set(BACKTRACE_LIBRARIES ${LIBEXECINFO_LIBRARIES})
else()
    set(BACKTRACE_SOURCE BacktraceNone.cpp)
endif()

set(PDAL_UTIL_SOURCES
    "${PDAL_UTIL_DIR}/Bounds.cpp"
    "${PDAL_UTIL_DIR}/Charbuf.cpp"
    "${PDAL_UTIL_DIR}/FileUtils.cpp"
    "${PDAL_UTIL_DIR}/Georeference.cpp"
    "${PDAL_UTIL_DIR}/ThreadPool.cpp"
    "${PDAL_UTIL_DIR}/Utils.cpp"
    "${PDAL_UTIL_DIR}/Backtrace.cpp"
    "${PDAL_UTIL_DIR}/Random.cpp"
    "${PDAL_UTIL_DIR}/private/${BACKTRACE_SOURCE}"
)

PDAL_ADD_FREE_LIBRARY(${PDAL_UTIL_LIB_NAME} SHARED ${PDAL_UTIL_SOURCES})
target_link_libraries(${PDAL_UTIL_LIB_NAME}
    PRIVATE
        ${BACKTRACE_LIBRARIES}
        ${PDAL_BOOST_LIB_NAME}
        ${CMAKE_DL_LIBS}
        ${CMAKE_THREAD_LIBS_INIT}
)
target_include_directories(${PDAL_UTIL_LIB_NAME} PRIVATE
    ${PDAL_VENDOR_DIR}/pdalboost)

set_target_properties(${PDAL_UTIL_LIB_NAME} PROPERTIES
    VERSION "${PDAL_BUILD_VERSION}"
    SOVERSION "${PDAL_API_VERSION}"
    CLEAN_DIRECT_OUTPUT 1)

set_property(GLOBAL PROPERTY _UTIL_INCLUDED TRUE)

=== plugins/cpd/CMakeLists.txt ===
set(Cpd_VERSION 0.5)

find_package(Cpd ${Cpd_VERSION} REQUIRED)
option(BUILD_PLUGIN_CPD "Build Coherent Point Drift support" ${Cpd_FOUND})

set(files filters/CpdFilter.cpp)
set(include_dirs "${CMAKE_CURRENT_LIST_DIR}" "${PDAL_VENDOR_DIR}/eigen")

PDAL_ADD_PLUGIN(filter_libname filter cpd
    FILES
        filters/CpdFilter.cpp
    LINK_WITH
        Cpd::Library-C++
    INCLUDES
        "${include_dirs}"
    )

if(${WITH_TESTS})
    PDAL_ADD_TEST(pdal_filters_cpd_test
        FILES
            test/CpdFilterTest.cpp
        LINK_WITH
            ${filter_libname}
        INCLUDES
            "${include_dirs}"
        )
endif()

=== plugins/draco/CMakeLists.txt ===
#
# Draco plugin CMake configuration
#
include (${PDAL_CMAKE_DIR}/draco.cmake)

if (NOT PDAL_HAVE_DRACO)
    message(FATAL_ERROR "Can't find Draco support required.")
endif()

if (WIN32)
    add_definitions(-DNOMINMAX)
endif()


#
# Draco Reader
#
PDAL_ADD_PLUGIN(reader_libname reader draco
    FILES
        io/DracoReader.cpp
    LINK_WITH
        ${DRACO_LIBRARIES}
    INCLUDES
        ${DRACO_INCLUDE_DIRS}
        ${NLOHMANN_INCLUDE_DIR}
)

target_link_libraries(${reader_libname}  PRIVATE ${DRACO_LIBRARY})
target_link_directories(${reader_libname} PRIVATE ${DRACO_LIBRARY_DIRS})

#
# Draco Writer
#

PDAL_ADD_PLUGIN(writer_libname writer draco
    FILES
        io/DracoWriter.cpp
    LINK_WITH
        ${DRACO_LIBRARIES}
    INCLUDES
        ${DRACO_INCLUDE_DIRS}
        ${NLOHMANN_INCLUDE_DIR}
)

target_link_directories(${writer_libname} PRIVATE ${DRACO_LIBRARY_DIRS})


if (WITH_TESTS)

    PDAL_ADD_TEST(pdal_io_draco_writer_test
        FILES
            test/DracoWriterTest.cpp
        LINK_WITH
            ${writer_libname}
            ${reader_libname}
        INCLUDES
            ${DRACO_INCLUDE_DIRS}
            ${NLOHMANN_INCLUDE_DIR}
    )
    target_link_directories(pdal_io_draco_writer_test PRIVATE ${DRACO_LIBRARY_DIRS})
    target_link_libraries(pdal_io_draco_writer_test  PRIVATE ${DRACO_LIBRARIES})

    PDAL_ADD_TEST(pdal_io_draco_reader_test
        FILES
            test/DracoReaderTest.cpp
        LINK_WITH
            ${reader_libname}
            ${writer_libname}
        INCLUDES
            ${DRACO_INCLUDE_DIRS}
            ${NLOHMANN_INCLUDE_DIR}
    )
    target_link_directories(pdal_io_draco_reader_test PRIVATE ${DRACO_LIBRARY_DIRS})
    target_link_libraries(pdal_io_draco_reader_test  PRIVATE ${DRACO_LIBRARIES})


endif()

=== plugins/fbx/CMakeLists.txt ===
#
# FBX plugin CMake configuration
#
find_package(Fbx 2016 REQUIRED)



if (APPLE)
    set(CORE_FOUNDATION "-framework CoreFoundation")
endif()

if (FBX_FOUND)
    PDAL_ADD_PLUGIN(writer_libname writer fbx
        FILES
            io/FbxWriter.cpp
        LINK_WITH
            ${FBX_LIBRARIES}
            ${CORE_FOUNDATION}
        INCLUDES
            ${PDAL_IO_DIR}
            ${FBX_INCLUDE_DIRS}
    )

    if (WITH_TESTS)
        PDAL_ADD_TEST(fbxtest
            FILES
                test/FbxWriterTest.cpp
            LINK_WITH
                ${writer_libname}
            INCLUDES
                ${PDAL_IO_DIRS}
        )
    endif()
else()
    message(STATUS "Building without FBX support")
endif()

=== plugins/hdf/CMakeLists.txt ===
#
# HDF plugin CMake configuration
#

include (${PDAL_CMAKE_DIR}/hdf5.cmake)


if (NOT PDAL_HAVE_HDF5)
    message(FATAL "HDF5 library is required to build HDF support.")
endif()

PDAL_ADD_PLUGIN(libname reader hdf
    FILES
        io/HdfReader.cpp
        io/Hdf5Handler.cpp
    LINK_WITH
        ${HDF5_LIBRARIES}
    INCLUDES
        ${ROOT_DIR}
        ${NLOHMANN_INCLUDE_DIR}
)

if (WITH_TESTS)
    PDAL_ADD_TEST(pdal_io_hdf_reader_test
        FILES test/HdfReadertest.cpp
        LINK_WITH ${libname}
        INCLUDES
            ${NLOHMANN_INCLUDE_DIR})
endif()

=== debian/changelog ===
pdal (2.3.0+ds-2) unstable; urgency=medium

  * Bump debhelper compat to 12, changes:
    - Drop --list-missing from dh_install
  * Add pkg-config to build dependencies.
  * Add patch to fix FTBFS with GCC 11.
    (closes: #984285)
  * Update symbols for amd64.
  * Update lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 11 Oct 2021 07:31:37 +0200

pdal (2.3.0+ds-1) unstable; urgency=medium

  * Update symbols for other architectures.
  * Bump Standards-Version to 4.6.0, no changes.
  * Update lintian overrides.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 07 Sep 2021 15:10:11 +0200

pdal (2.3.0+ds-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 29 May 2021 07:20:26 +0200

pdal (2.3+ds-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Drop presentations from repacking, removed upstream.
  * Update copyright file.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 28 May 2021 05:52:18 +0200

pdal (2.3~rc1+ds-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Bump watch file version to 4.
  * Update lintian overrides.
  * Bump Standards-Version to 4.5.1, no changes.
  * Update watch file for GitHub URL changes.
  * Update uversionmangle to use lowercase RC.
  * Rename library package for SONAME bump.
  * Require at least libgdal-dev 3.0.
  * Update copyright file.
  * Enable Draco plugin.
  * Refresh patches.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 19 May 2021 17:03:23 +0200

=== debian/control ===
Source: pdal
Section: science
Priority: optional
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Bas Couwenberg <sebastic@debian.org>
Build-Depends: debhelper-compat (= 12),
               bash-completion,
               chrpath,
               cmake (>= 3.5),
               gdal-bin,
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libdraco-dev,
               libgdal-dev (>= 3.0),
               libgeotiff-dev,
               libhdf5-dev,
               libjs-mathjax,
               liblaszip-dev,
               libpq-dev,
               libwebsocketpp-dev,
               libxerces-c-dev,
               libxml2-dev,
               libzstd-dev,
               pkg-config,
               pkg-kde-tools,
               python3-breathe,
               python3-sphinx,
               python3-sphinx-rtd-theme,
               python3-sphinxcontrib.bibtex,
               python3-sphinxcontrib.spelling,
               zlib1g-dev,
               docbook2x,
               docbook-xsl,
               docbook-xml,
               xsltproc
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/debian-gis-team/pdal
Vcs-Git: https://salsa.debian.org/debian-gis-team/pdal.git
Homepage: http://pdal.io/

Package: pdal
Architecture: any
Section: utils
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: pdal-doc
Description: Point Data Abstraction Library
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the PDAL utilities.

Package: pdal-doc
Architecture: all
Section: doc
Depends: libjs-mathjax,
         ${sphinxdoc:Depends},
         ${misc:Depends}
Suggests: libpdal-dev,
          pdal
Description: Point Data Abstraction Library - documentation
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the PDAL documentation.

Package: libpdal-base13
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: libpdal-plugins
Description: Point Data Abstraction Library - libpdal_base
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the libpdal_base shared library.

Package: libpdal-util13
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - libpdal_util
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the libpdal_util shared library.

Package: libpdal-dev
Architecture: any
Section: libdevel
Depends: libpdal-base13 (= ${binary:Version}),
         libpdal-util13 (= ${binary:Version}),
         libboost-filesystem-dev,
         libboost-iostreams-dev,
         libboost-program-options-dev,
         libboost-system-dev,
         libboost-thread-dev,
         libgdal-dev,
         libgeos++-dev,
         libgeotiff-dev,
         liblaszip-dev,
         libproj-dev,
         libxml2-dev,
         ${misc:Depends}
Suggests: pdal-doc
Description: Point Data Abstraction Library - development files
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the PDAL development files.

Package: libpdal-plugins
Architecture: any
Section: libs
Depends: libpdal-plugin-draco (= ${binary:Version}),
         libpdal-plugin-e57 (= ${binary:Version}),
         libpdal-plugin-faux (= ${binary:Version}),
         libpdal-plugin-hdf (= ${binary:Version}),
         libpdal-plugin-i3s (= ${binary:Version}),
         libpdal-plugin-icebridge (= ${binary:Version}),
         libpdal-plugin-pgpointcloud (= ${binary:Version}),
         ${misc:Depends}
Description: Point Data Abstraction Library - plugins
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This metapackage depends on the individual PDAL plugin packages.

Package: libpdal-plugin-draco
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - Draco plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the Draco plugin.

Package: libpdal-plugin-e57
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - E57 plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the E57 plugin.

Package: libpdal-plugin-faux
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - Faux plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the Faux plugin.

Package: libpdal-plugin-hdf
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - HDF plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the HDF plugin.

Package: libpdal-plugin-i3s
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - I3S plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

include /usr/share/dpkg/pkg-info.mk

CXXFLAGS += $(CPPFLAGS)

UPSTREAM_VERSION  = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

BUILD_DATE = $(shell LC_ALL=C date -u "+%d %B %Y" -d "@$(SOURCE_DATE_EPOCH)")

MANPAGES := $(wildcard debian/man/*.*.xml)

%:
	dh $@ --with pkgkde_symbolshelper,sphinxdoc

override_dh_clean:
	dh_clean debian/man/*.1

	$(RM) -r doc/html

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=RelWithDebInfo \
	                     -DCMAKE_INSTALL_LIBDIR=lib \
	                     -DBUILD_PLUGIN_DRACO=ON \
	                     -DBUILD_PLUGIN_E57=ON \
	                     -DBUILD_PLUGIN_HDF=ON \
	                     -DBUILD_PLUGIN_I3S=ON \
	                     -DBUILD_PLUGIN_ICEBRIDGE=ON \
	                     -DWITH_COMPLETION=ON

override_dh_auto_build:
	# Create man pages from DocBook XML
	for x in $(MANPAGES) ; do \
	  docbook2x-man --string-param header-3="$(BUILD_DATE)" $$x ; \
	  mv `basename $$x | sed 's/.xml$$//'` `dirname $$x` ; \
	done

	dh_auto_build

	sphinx-build doc/ doc/html/ && ln -s /usr/share/javascript/mathjax doc/html/_static/

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Exclude tests:
	# - pgpointcloudtest, requires configured PostgreSQL database
	# - pdal_spatial_reference_test, fails sometimes
	(cd obj-* && ctest --force-new-ctest-process --output-on-failure --exclude-regex "pgpointcloudtest|pdal_spatial_reference_test" || echo "Ignoring test failures")
endif

override_dh_auto_install:
	dh_auto_install

	# Strip RPATH
	chrpath --delete debian/tmp/usr/lib/libpdal_plugin_*.so

	# Move pkg-config file to Multi-Arch path
	mkdir debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/lib/pkgconfig debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/

	# Remove empty directories
	rmdir $(CURDIR)/debian/*/usr/include/pdal/filters/private/csf
	rmdir $(CURDIR)/debian/*/usr/include/pdal/filters/private/miniball

override_dh_makeshlibs:
	dh_makeshlibs -- -v$(UPSTREAM_VERSION) -c0
